package sorting.algorithms;

import sorting.model.ObservableArray;
import sorting.model.ObservableArray.DataState;

class InsertionSort extends Algorithm {

    public String name() {
    	return "Insertion sort" ;
    }
    
    @Override
    public void go(ObservableArray array) throws InterruptedException {
    	// Invariant. The first i items are sorted.
        for( int i=1 ; i < array.length() ; ++i ) {
        	int subject = array.get(i) ;
            array.setHighlight(i, DataState.RED) ;
            pause(1);
        	for( int j = i; j > 0 ; --j ) {
                array.setHighlight(j-1, DataState.BLUE) ;
                pause(1) ;
                if( array.get(j-1) <= subject ) {
                    array.setHighlight(j-1, DataState.WHITE) ;
                    array.setHighlight(j, DataState.WHITE) ;
                	break ;
                }
                pause(1) ;
                array.set( j, array.get(j-1) ) ;
                array.set( j-1, subject ) ;
                array.setHighlight(j-1, DataState.RED) ;
                array.setHighlight(j, DataState.BLUE) ;
                pause(1) ;
                array.setHighlight(j, DataState.WHITE) ;
                pause(1) ; }
        	array.setHighlight(0, DataState.WHITE) ;
        	pause(3) ;
        }
       }
    
}