package sorting.views;

import javax.swing.JPanel;

import sorting.model.ObservableArray;
import util.Assert;

public class ViewFactory {
	public int getViewCount() {
		return 3 ;
	}
	
	public JPanel makeView( int i, ObservableArray array ) {
		switch( i ) {
		case 0: return new ListViewOfArray( array ) ;
		case 1: return new Histogram( array ) ;
		case 2: return new Histogram( array ) ;
		default:
			Assert.check( false, "Bad parameter to makeView." ) ;
			return null ; }
	}
}
