package sorting.algorithms;

import sorting.model.ObservableArray;

abstract public class Algorithm {
	
	public abstract void go( ObservableArray array ) throws InterruptedException ;
	
	public abstract String name() ;

	public static void pause(int i) throws InterruptedException {
        final int scaleIn_ms = 500 ;
        Thread.sleep( i* scaleIn_ms ); }
}
