package sorting.algorithms;

import sorting.model.ObservableArray;
import sorting.model.ObservableArray.DataState;

class SelectionSort extends Algorithm {

    public String name() {
    	return "Selection Sort" ;
    }
    
    @Override
    public void go(ObservableArray array) throws InterruptedException {
        
        for( int i=0 ; i < array.length() ; ++i ) {
            int max = i ;
            array.setHighlight(max, DataState.RED) ; // 1 highlight
            pause( 1 ) ;
            for( int j=i+1 ; j < array.length() ; ++j ) {
                array.setHighlight(j, DataState.RED) ; // 2 highlights
                pause(1) ;
                if( array.get(j) < array.get(max) ) {
                    array.setHighlight(max, DataState.BLACK) ; //1
                    max = j ;
                    pause(1) ; }
                else {
                    array.setHighlight(j, DataState.BLACK ); } } //1
            pause(2) ;
            if( i != max ) {
                array.setHighlight(i, DataState.BLUE) ; // 1
                array.setHighlight(max, DataState.RED) ;  // 2
                pause(1) ;
                int temp = array.get(max) ;
                array.set( max, array.get(i) ) ;
                array.set( i, temp ) ;
                array.setHighlight(i, DataState.RED) ; // 2
                array.setHighlight(max, DataState.BLUE) ;  // 2
                pause(1) ; }
            array.setHighlight(max, DataState.BLACK) ;
            array.setHighlight(i, DataState.WHITE) ;
            pause(3) ;} // 0 
    }
}